diff -pru mailman-cvs-HEAD/Mailman/Defaults.py.in mailman-2.1.7.cg/Mailman/Defaults.py.in
--- mailman-cvs-HEAD/Mailman/Defaults.py.in	2006-01-15 22:05:42.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Defaults.py.in	2006-03-04 18:29:11.000000000 +0100
@@ -1,6 +1,6 @@
 # -*- python -*-
 
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -476,7 +476,6 @@ GLOBAL_PIPELINE = [
     'CalcRecips',
     'AvoidDuplicates',
     'Cleanse',
-    'CleanseDKIM',
     'CookHeaders',
     # And now we send the message to the digest mbox file, and to the arch and
     # news queues.  Runners will provide further processing of the message,
@@ -495,7 +494,6 @@ GLOBAL_PIPELINE = [
 OWNER_PIPELINE = [
     'SpamDetect',
     'Replybot',
-    'CleanseDKIM',
     'OwnerRecips',
     'ToOutgoing',
     ]
@@ -830,7 +828,7 @@ DEFAULT_MSG_HEADER = ""
 DEFAULT_MSG_FOOTER = """_______________________________________________
 %(real_name)s mailing list
 %(real_name)s@%(host_name)s
-%(web_page_url)slistinfo%(cgiext)s/%(_internal_name)s
+%(web_page_url)slistinfo%(cgiext)s/%(local_part)s
 """
 
 # Where to put subject prefix for 'Re:' messages:
@@ -1309,57 +1307,44 @@ from Version import *
 # element being the description, as described in the catalogs, and second
 # element is the language charset.  I have chosen code from /usr/share/locale
 # in my GNU/Linux. :-)
-# TK: Now the site admin can select languages for the installation from
-# those in the distribution tarball.  We don't touch add_language() function
-# for backward compatibility in mm_cfg.py syntax.  You may have to add your
-# own language in mm_cfg.py if it is not included in the distribution even
-# if you had put language files in source directory and configured by
-# `--with-languages' option.
 def _(s):
     return s
 
-LANGUAGES = 'en ' + '@LANGUAGES@'
-LANGUAGE_DICT = {
-	'ca':   (_('Catalan'),             'iso-8859-1'),
-	'cs':   (_('Czech'),               'iso-8859-2'),
-	'da':   (_('Danish'),              'iso-8859-1'),
-	'de':   (_('German'),              'iso-8859-1'),
-	'en':   (_('English (USA)'),       'us-ascii'),
-	'es':   (_('Spanish (Spain)'),     'iso-8859-1'),
-	'et':   (_('Estonian'),            'iso-8859-15'),
-	'eu':   (_('Euskara'),             'iso-8859-15'), # Basque
-	'fi':   (_('Finnish'),             'iso-8859-1'),
-	'fr':   (_('French'),              'iso-8859-1'),
-	'hr':   (_('Croatian'),            'iso-8859-2'),
-	'hu':   (_('Hungarian'),           'iso-8859-2'),
-        'ia':   (_('Interlingua'),         'iso-8859-15'),
-	'it':   (_('Italian'),             'iso-8859-1'),
-	'ja':   (_('Japanese'),            'euc-jp'),
-	'ko':   (_('Korean'),              'euc-kr'),
-	'lt':   (_('Lithuanian'),          'iso-8859-13'),
-	'nl':   (_('Dutch'),               'iso-8859-1'),
-	'no':   (_('Norwegian'),           'iso-8859-1'),
-	'pl':   (_('Polish'),              'iso-8859-2'),
-	'pt':   (_('Portuguese'),          'iso-8859-1'),
-	'pt_BR':(_('Portuguese (Brazil)'), 'iso-8859-1'),
-	'ro':   (_('Romanian'),            'iso-8859-2'),
-	'ru':   (_('Russian'),             'koi8-r'),
-	'sr':   (_('Serbian'),             'utf-8'),
-	'sl':   (_('Slovenian'),           'iso-8859-2'),
-	'sv':   (_('Swedish'),             'iso-8859-1'),
-	'tr':   (_('Turkish'),             'iso-8859-9'),
-	'uk':   (_('Ukrainian'),           'utf-8'),
-	'zh_CN':(_('Chinese (China)'),     'utf-8'),
-	'zh_TW':(_('Chinese (Taiwan)'),    'utf-8'),
-}
-
 LC_DESCRIPTIONS = {}
 
 def add_language(code, description, charset):
     LC_DESCRIPTIONS[code] = (description, charset)
 
-for lang in LANGUAGES.split():
-    if lang in LANGUAGE_DICT.keys():
-        add_language(lang, LANGUAGE_DICT[lang][0], LANGUAGE_DICT[lang][1])
+add_language('ca',    _('Catalan'),             'iso-8859-1')
+add_language('cs',    _('Czech'),               'iso-8859-2')
+add_language('da',    _('Danish'),              'iso-8859-1')
+add_language('de',    _('German'),              'iso-8859-1')
+add_language('en',    _('English (USA)'),       'us-ascii')
+add_language('es',    _('Spanish (Spain)'),     'iso-8859-1')
+add_language('et',    _('Estonian'),            'iso-8859-15')
+add_language('eu',    _('Euskara'),             'iso-8859-15') # Basque
+add_language('fi',    _('Finnish'),             'iso-8859-1')
+add_language('fr',    _('French'),              'iso-8859-1')
+add_language('hr',    _('Croatian'),            'iso-8859-2')
+add_language('hu',    _('Hungarian'),           'iso-8859-2')
+add_language('ia',    _('Interlingua'),         'iso-8859-15')
+add_language('it',    _('Italian'),             'iso-8859-1')
+add_language('ja',    _('Japanese'),            'euc-jp')
+add_language('ko',    _('Korean'),              'euc-kr')
+add_language('lt',    _('Lithuanian'),          'iso-8859-13')
+add_language('nl',    _('Dutch'),               'iso-8859-1')
+add_language('no',    _('Norwegian'),           'iso-8859-1')
+add_language('pl',    _('Polish'),              'iso-8859-2')
+add_language('pt',    _('Portuguese'),          'iso-8859-1')
+add_language('pt_BR', _('Portuguese (Brazil)'), 'iso-8859-1')
+add_language('ro',    _('Romanian'),            'iso-8859-2')
+add_language('ru',    _('Russian'),             'koi8-r')
+add_language('sr',    _('Serbian'),             'utf-8')
+add_language('sl',    _('Slovenian'),           'iso-8859-2')
+add_language('sv',    _('Swedish'),             'iso-8859-1')
+add_language('tr',    _('Turkish'),             'iso-8859-9')
+add_language('uk',    _('Ukrainian'),           'utf-8')
+add_language('zh_CN', _('Chinese (China)'),     'utf-8')
+add_language('zh_TW', _('Chinese (Taiwan)'),    'utf-8')
 
 del _
diff -pru mailman-cvs-HEAD/Mailman/Deliverer.py mailman-2.1.7.cg/Mailman/Deliverer.py
--- mailman-cvs-HEAD/Mailman/Deliverer.py	2005-12-30 19:56:44.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Deliverer.py	2006-03-04 12:31:03.000000000 +0100
@@ -158,9 +158,8 @@ your membership administrative address, 
         # Some one was invited to one list but tried to confirm to a different
         # list.  We inform both list owners of the bogosity, but be careful
         # not to reveal too much information.
-        selfname = self.internal_name()
         syslog('mischief', '%s was invited to %s but confirmed to %s',
-               address, listname, selfname)
+               address, listname, self.internal_name())
         # First send a notice to the attacked list
         msg = Message.OwnerNotification(
             self,
@@ -207,7 +206,7 @@ is required.""")))
         # probe message.
         token = self.pend_new(Pending.PROBE_BOUNCE, member, msg)
         probedict = {
-            'bounces': self.internal_name() + '-bounces',
+            'bounces': self.getListAddress('bounces'),
             'token': token,
             }
         probeaddr = '%s@%s' % ((mm_cfg.VERP_PROBE_FORMAT % probedict),
diff -pru mailman-cvs-HEAD/Mailman/Gui/Digest.py mailman-2.1.7.cg/Mailman/Gui/Digest.py
--- mailman-cvs-HEAD/Mailman/Gui/Digest.py	2005-08-27 03:54:02.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Gui/Digest.py	2006-03-04 18:41:06.000000000 +0100
@@ -25,8 +25,9 @@ from Mailman.Gui.GUIBase import GUIBase
 
 # Common b/w nondigest and digest headers & footers.  Personalizations may add
 # to this.
+# NDIM XXX remove _internal_name?
 ALLOWEDS = ('real_name', 'list_name', 'host_name', 'web_page_url',
-            'description', 'info', 'cgiext', '_internal_name',
+            'description', 'info', 'cgiext', '_internal_name', 'local_part',
             )
 
 
diff -pru mailman-cvs-HEAD/Mailman/Gui/General.py mailman-2.1.7.cg/Mailman/Gui/General.py
--- mailman-cvs-HEAD/Mailman/Gui/General.py	2005-10-07 05:07:22.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Gui/General.py	2006-02-21 07:44:48.000000000 +0100
@@ -419,7 +419,7 @@ class General(GUIBase):
 
     def _setValue(self, mlist, property, val, doc):
         if property == 'real_name' and \
-               val.lower() <> mlist.internal_name().lower():
+               val.lower() <> mlist.real_name.lower():
             # These values can't differ by other than case
             doc.addError(_("""<b>real_name</b> attribute not
             changed!  It must differ from the list's name by case
diff -pru mailman-cvs-HEAD/Mailman/Gui/Privacy.py mailman-2.1.7.cg/Mailman/Gui/Privacy.py
--- mailman-cvs-HEAD/Mailman/Gui/Privacy.py	2005-12-30 19:56:46.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Gui/Privacy.py	2005-12-30 19:50:08.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 2001-2003 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
diff -pru mailman-cvs-HEAD/Mailman/Gui/Topics.py mailman-2.1.7.cg/Mailman/Gui/Topics.py
--- mailman-cvs-HEAD/Mailman/Gui/Topics.py	2006-01-15 00:58:37.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Gui/Topics.py	2006-02-21 07:21:11.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2003 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 import re
 
diff -pru mailman-cvs-HEAD/Mailman/Handlers/Approve.py mailman-2.1.7.cg/Mailman/Handlers/Approve.py
--- mailman-cvs-HEAD/Mailman/Handlers/Approve.py	2005-12-30 19:56:46.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/Approve.py	2005-12-30 19:50:08.000000000 +0100
@@ -30,6 +30,13 @@ from email.Iterators import typed_subpar
 from Mailman import mm_cfg
 from Mailman import Errors
 
+# True/False
+try:
+    True, False
+except NameError:
+    True = 1
+    False = 0
+
 NL = '\n'
 
 
diff -pru mailman-cvs-HEAD/Mailman/Handlers/Cleanse.py mailman-2.1.7.cg/Mailman/Handlers/Cleanse.py
--- mailman-cvs-HEAD/Mailman/Handlers/Cleanse.py	2006-01-15 22:03:55.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/Cleanse.py	2005-12-30 19:50:08.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -50,3 +50,12 @@ def process(mlist, msg, msgdata):
     del msg['x-confirm-reading-to']
     # Pegasus mail uses this one... sigh
     del msg['x-pmrqc']
+    # Remove any "DomainKeys" (or similar) header lines.  The values contained
+    # in these header lines are intended to be used by the recipient to detect
+    # forgery or tampering in transit, and the modifications made by Mailman
+    # to the headers and body of the message will cause these keys to appear
+    # invalid.  Removing them will at least avoid this misleading result, and
+    # it will also give the MTA the opportunity to regenerate valid keys
+    # originating at the Mailman server for the outgoing message.
+    del msg['domainkey-signature']
+    del msg['dkim-signature']
diff -pru mailman-cvs-HEAD/Mailman/Handlers/CookHeaders.py mailman-2.1.7.cg/Mailman/Handlers/CookHeaders.py
--- mailman-cvs-HEAD/Mailman/Handlers/CookHeaders.py	2006-02-17 03:48:34.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/CookHeaders.py	2006-03-04 08:59:18.000000000 +0100
@@ -180,7 +180,7 @@ def process(mlist, msg, msgdata):
     if msgdata.get('_nolist') or not mlist.include_rfc2369_headers:
         return
     # This will act like an email address for purposes of formataddr()
-    listid = '%s.%s' % (mlist.internal_name(), mlist.host_name)
+    listid = '%s.%s' % (mlist.local_part, mlist.host_name)
     cset = Utils.GetCharSet(mlist.preferred_language)
     if mlist.description:
         # Don't wrap the header since here we just want to get it properly RFC
@@ -327,33 +327,30 @@ def prefix_subject(mlist, msg, msgdata):
 
 
 
-def ch_oneline(headerstr):
+def ch_oneline(s):
     # Decode header string in one line and convert into single charset
     # copied and modified from ToDigest.py and Utils.py
     # return (string, cset) tuple as check for failure
     try:
-        d = decode_header(headerstr)
-        # At this point, we should rstrip() every string because some
+        d = decode_header(s)
+        # at this point, we should rstrip() every string because some
         # MUA deliberately add trailing spaces when composing return
         # message.
-        d = [(s.rstrip(),c) for (s,c) in d]
-        # Find all charsets in the original header.  We use 'utf-8' rather
-        # than using the first charset (in mailman 2.1.x) if multiple
-        # charsets are used.
-        csets = []
+        i = 0
         for (s,c) in d:
-            if c and c not in csets:
-                csets.append(c)
-        if len(csets) == 0:
-            cset = 'us-ascii'
-        elif len(csets) == 1:
-            cset = csets[0]
-        else:
-            cset = 'utf-8'
+            s = s.rstrip()
+            d[i] = (s,c)
+            i += 1
+        cset = 'us-ascii'
+        for x in d:
+            # search for no-None charset
+            if x[1]:
+                cset = x[1]
+                break
         h = make_header(d)
-        ustr = unicode(h)
+        ustr = h.__unicode__()
         oneline = u''.join(ustr.splitlines())
         return oneline.encode(cset, 'replace'), cset
     except (LookupError, UnicodeError, ValueError, HeaderParseError):
         # possibly charset problem. return with undecoded string in one line.
-        return ''.join(headerstr.splitlines()), 'us-ascii'
+        return ''.join(s.splitlines()), 'us-ascii'
diff -pru mailman-cvs-HEAD/Mailman/Handlers/Decorate.py mailman-2.1.7.cg/Mailman/Handlers/Decorate.py
--- mailman-cvs-HEAD/Mailman/Handlers/Decorate.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/Decorate.py	2006-03-04 18:54:25.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -98,7 +98,12 @@ def process(mlist, msg, msgdata):
         uheader = unicode(header, lcset)
         ufooter = unicode(footer, lcset)
         try:
-            oldpayload = unicode(msg.get_payload(decode=True), mcset)
+            # First, check if the message was Scrubber-munged
+            if msg.get('x-mailman-scrubbed'):
+                decode = False
+            else:
+                decode = True
+            oldpayload = unicode(msg.get_payload(decode=decode), mcset)
             frontsep = endsep = u''
             if header and not header.endswith('\n'):
                 frontsep = u'\n'
@@ -121,7 +126,7 @@ def process(mlist, msg, msgdata):
             wrap = False
         except (LookupError, UnicodeError):
             pass
-    elif msg.get_content_type() == 'multipart/mixed':
+    elif msg.get_type() == 'multipart/mixed':
         # The next easiest thing to do is just prepend the header and append
         # the footer as additional subparts
         payload = msg.get_payload()
@@ -193,12 +198,12 @@ def decorate(mlist, template, what, extr
     # example, a footer of "% silly %(real_name)s" would give a header
     # containing all list attributes.  While we've previously removed such
     # really bad ones like `password' and `passwords', it's much better to
-    # provide a whitelist of known good attributes, then to try to remove a
+    # provide a whitelist of known good attributes, than to try to remove a
     # blacklist of known bad ones.
     d = SafeDict({'real_name'     : mlist.real_name,
-                  'list_name'     : mlist.internal_name(),
+                  'list_name'     : mlist.local_part,
                   # For backwards compatibility
-                  '_internal_name': mlist.internal_name(),
+                  '_internal_name': mlist.local_part,
                   'host_name'     : mlist.host_name,
                   'web_page_url'  : mlist.web_page_url,
                   'description'   : mlist.description,
diff -pru mailman-cvs-HEAD/Mailman/Handlers/Hold.py mailman-2.1.7.cg/Mailman/Handlers/Hold.py
--- mailman-cvs-HEAD/Mailman/Handlers/Hold.py	2005-09-19 05:23:11.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Handlers/Hold.py	2006-03-04 18:51:57.000000000 +0100
@@ -129,12 +129,13 @@ def process(mlist, msg, msgdata):
         return
     # Get the sender of the message
     listname = mlist.internal_name()
-    adminaddr = listname + '-admin'
+    adminaddr = mlist.getListAddress('admin')
     sender = msg.get_sender()
     # Special case an ugly sendmail feature: If there exists an alias of the
     # form "owner-foo: bar" and sendmail receives mail for address "foo",
     # sendmail will change the envelope sender of the message to "bar" before
     # delivering.  This feature does not appear to be configurable.  *Boggle*.
+    # NDIM XXX Handle listname == 'foo@blah.com'
     if not sender or sender[:len(listname)+6] == adminaddr:
         sender = msg.get_sender(use_envelope=0)
     #
diff -pru mailman-cvs-HEAD/Mailman/Handlers/Scrubber.py mailman-2.1.7.cg/Mailman/Handlers/Scrubber.py
--- mailman-cvs-HEAD/Mailman/Handlers/Scrubber.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/Scrubber.py	2005-12-30 19:50:08.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -111,9 +111,9 @@ class ScrubberGenerator(Generator):
             Generator._write_headers(self, msg)
 
 
-def safe_strftime(fmt, t):
+def safe_strftime(fmt, floatsecs):
     try:
-        return time.strftime(fmt, t)
+        return time.strftime(fmt, floatsecs)
     except (TypeError, ValueError, OverflowError):
         return None
 
@@ -164,10 +164,12 @@ def calculate_attachments_dir(mlist, msg
 
 def replace_payload_by_text(msg, text, charset):
     # TK: This is a common function in replacing the attachment and the main
-    # message by a text (scrubbing).
+    # message by a text (scrubbing).  Also, add a flag indicating it has been
+    # scrubbed.
     del msg['content-type']
     del msg['content-transfer-encoding']
     msg.set_payload(text, charset)
+    msg['X-Mailman-Scrubbed'] = 'Yes'
 
 
 
@@ -188,7 +190,7 @@ def process(mlist, msg, msgdata=None):
     lcset_out = Charset(lcset).output_charset or lcset
     # Now walk over all subparts of this message and scrub out various types
     for part in msg.walk():
-        ctype = part.get_content_type()
+        ctype = part.get_type(part.get_default_type())
         # If the part is text/plain, we leave it alone
         if ctype == 'text/plain':
             # We need to choose a charset for the scrubbed message, so we'll
@@ -286,7 +288,7 @@ Url: %(url)s
         # will transform the url into a hyperlink.
         elif part and not part.is_multipart():
             payload = part.get_payload(decode=True)
-            ctype = part.get_content_type()
+            ctype = part.get_type()
             # XXX Under email 2.5, it is possible that payload will be None.
             # This can happen when you have a Content-Type: multipart/* with
             # only one part and that part has two blank lines between the
@@ -342,13 +344,13 @@ Url : %(url)s
                 text.append(_('Skipped content of type %(partctype)s\n'))
                 continue
             try:
-                t = part.get_payload(decode=True)
-            # MAS: TypeError exception can occur if payload is None. This
-            # was observed with a message that contained an attached
-            # message/delivery-status part. Because of the special parsing
-            # of this type, this resulted in a text/plain sub-part with a
-            # null body. See bug 1430236.
-            except (binascii.Error, TypeError):
+                # Check if the part is replaced.
+                if part.get('x-mailman-scrubbed'):
+                    decode = False
+                else:
+                    decode = True
+                t = part.get_payload(decode=decode)
+            except binascii.Error:
                 t = part.get_payload()
             # TK: get_content_charset() returns 'iso-2022-jp' for internally
             # crafted (scrubbed) 'euc-jp' text part. So, first try
diff -pru mailman-cvs-HEAD/Mailman/Handlers/SMTPDirect.py mailman-2.1.7.cg/Mailman/Handlers/SMTPDirect.py
--- mailman-cvs-HEAD/Mailman/Handlers/SMTPDirect.py	2005-12-30 19:56:46.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/SMTPDirect.py	2006-03-04 18:54:50.000000000 +0100
@@ -175,7 +175,7 @@ def process(mlist, msg, msgdata):
                           'size'    : len(msg.as_string()),
                           '#recips' : len(recips),
                           '#refused': len(refused),
-                          'listname': mlist.internal_name(),
+                          'listname': mlist.local_part,
                           'sender'  : origsender,
                           })
     # We have to use the copy() method because extended call syntax requires a
diff -pru mailman-cvs-HEAD/Mailman/Handlers/Tagger.py mailman-2.1.7.cg/Mailman/Handlers/Tagger.py
--- mailman-cvs-HEAD/Mailman/Handlers/Tagger.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/Tagger.py	2005-08-27 03:40:16.000000000 +0200
@@ -69,12 +69,11 @@ def scanbody(msg, numlines=None):
     # or if the outer type is multipart/alternative and there is a text/plain
     # part.  Anything else, and the body is ignored for header-scan purposes.
     found = None
-    if msg.get_content_type() == 'text/plain':
+    if msg.get_type('text/plain') == 'text/plain':
         found = msg
-    elif msg.is_multipart()\
-         and msg.get_content_type() == 'multipart/alternative':
+    elif msg.is_multipart() and msg.get_type() == 'multipart/alternative':
         for found in msg.get_payload():
-            if found.get_content_type() == 'text/plain':
+            if found.get_type('text/plain') == 'text/plain':
                 break
         else:
             found = None
diff -pru mailman-cvs-HEAD/Mailman/Handlers/ToArchive.py mailman-2.1.7.cg/Mailman/Handlers/ToArchive.py
--- mailman-cvs-HEAD/Mailman/Handlers/ToArchive.py	2006-01-29 06:13:57.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/ToArchive.py	2005-12-30 19:50:08.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -20,7 +20,10 @@
 import time
 from cStringIO import StringIO
 
+from email import message_from_string
+
 from Mailman import mm_cfg
+from Mailman import Message
 from Mailman.Queue.sbcache import get_switchboard
 
 
@@ -37,4 +40,10 @@ def process(mlist, msg, msgdata):
     # Send the message to the archiver queue
     archq = get_switchboard(mm_cfg.ARCHQUEUE_DIR)
     # Send the message to the queue
-    archq.enqueue(msg, msgdata)
+    if msg.get('x-mailman-scrubbed'):
+        # Clean Scrubber-munged message.
+        archmsg = message_from_string(msg.as_string(), Message.Message)
+        del archmsg['x-mailman-scrubbed']
+        archq.enqueue(archmsg, msgdata)
+    else:
+        archq.enqueue(msg, msgdata)
diff -pru mailman-cvs-HEAD/Mailman/Handlers/ToDigest.py mailman-2.1.7.cg/Mailman/Handlers/ToDigest.py
--- mailman-cvs-HEAD/Mailman/Handlers/ToDigest.py	2006-01-29 06:13:57.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/ToDigest.py	2005-12-30 19:50:08.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -32,6 +32,7 @@ import time
 from types import ListType
 from cStringIO import StringIO
 
+from email import message_from_string
 from email.Parser import Parser
 from email.Generator import Generator
 from email.MIMEBase import MIMEBase
@@ -332,10 +333,14 @@ def send_i18n_digests(mlist, mboxfp):
                 uh = '\n\t'.join(uh.split('\n'))
                 print >> plainmsg, uh
         print >> plainmsg
-        # If decoded payload is empty, this may be multipart message.
-        # -- just stringfy it.
-        payload = msg.get_payload(decode=True) \
-                  or msg.as_string().split('\n\n',1)[1]
+        if msg.get('x-mailman-scrubbed'):
+            # It has successfully been scrubbed, so this should be string.
+            payload = msg.get_payload()
+        else:
+            # If decoded payload is empty, this may be multipart message.
+            # -- just stringfy it.
+            payload = msg.get_payload(decode=True) \
+                      or msg.as_string().split('\n\n',1)[1]
         mcset = msg.get_content_charset('')
         if mcset and mcset <> lcset and mcset <> lcset_out:
             try:
@@ -407,6 +412,8 @@ def send_i18n_digests(mlist, mboxfp):
                     isdigest=True)
     # RFC 1153
     rfc1153msg.set_payload(plainmsg.getvalue(), lcset)
+    # Re-generate it because set_payload() doesn't encode. :-(
+    rfc1153msg = message_from_string(rfc1153msg.as_string(), Message.Message)
     virginq.enqueue(rfc1153msg,
                     recips=plainrecips,
                     listname=mlist.internal_name(),
diff -pru mailman-cvs-HEAD/Mailman/HTMLFormatter.py mailman-2.1.7.cg/Mailman/HTMLFormatter.py
--- mailman-cvs-HEAD/Mailman/HTMLFormatter.py	2005-08-27 03:54:02.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/HTMLFormatter.py	2006-03-04 18:43:07.000000000 +0100
@@ -381,7 +381,8 @@ class HTMLFormatter:
         d = {
             '<mm-mailman-footer>' : self.GetMailmanFooter(),
             '<mm-list-name>' : self.real_name,
-            '<mm-email-user>' : self._internal_name,
+            '<mm-email-user>' : self.local_part,
+            '<mm-complete-name>' : self.internal_name(),
             '<mm-list-description>' : self.description,
             '<mm-list-info>' : BR.join(self.info.split(NL)),
             '<mm-form-end>'  : self.FormatFormEnd(),
diff -pru mailman-cvs-HEAD/Mailman/i18n.py mailman-2.1.7.cg/Mailman/i18n.py
--- mailman-cvs-HEAD/Mailman/i18n.py	2006-02-23 07:25:47.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/i18n.py	2005-08-27 03:40:15.000000000 +0200
@@ -1,4 +1,4 @@
-# Copyright (C) 2000-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2000-2003 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 import sys
 import time
@@ -108,12 +107,7 @@ def ctime(date):
     if isinstance(date, StringType):
         try:
             year, mon, day, hh, mm, ss, wday, ydat, dst = time.strptime(date)
-            if dst in (0,1):
-                tzname = time.tzname[dst]
-            else:
-                # MAS: No exception but dst = -1 so try
-                return ctime(time.mktime((year, mon, day, hh, mm, ss, wday,
-                                          ydat, dst)))
+            tzname = time.tzname[dst and 1 or 0]
         except (ValueError, AttributeError):
             try:
                 wday, mon, day, hms, year = date.split()
@@ -138,8 +132,7 @@ def ctime(date):
                         break
     else:
         year, mon, day, hh, mm, ss, wday, yday, dst = time.localtime(date)
-        if dst in (0,1):
-            tzname = time.tzname[dst]
+        tzname = time.tzname[dst and 1 or 0]
 
     wday = daysofweek[wday]
     mon = months[mon]
diff -pru mailman-cvs-HEAD/Mailman/ListAdmin.py mailman-2.1.7.cg/Mailman/ListAdmin.py
--- mailman-cvs-HEAD/Mailman/ListAdmin.py	2005-08-28 07:31:26.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/ListAdmin.py	2006-03-08 17:45:56.000000000 +0100
@@ -392,7 +392,7 @@ class ListAdmin:
             text = Utils.maketext(
                 'subauth.txt',
                 {'username'   : addr,
-                 'listname'   : self.internal_name(),
+                 'listname'   : self.local_part,
                  'hostname'   : self.host_name,
                  'admindb_url': self.GetScriptURL('admindb', absolute=1),
                  }, mlist=self)
@@ -444,7 +444,7 @@ class ListAdmin:
             text = Utils.maketext(
                 'unsubauth.txt',
                 {'username'   : addr,
-                 'listname'   : self.internal_name(),
+                 'listname'   : self.local_part,
                  'hostname'   : self.host_name,
                  'admindb_url': self.GetScriptURL('admindb', absolute=1),
                  }, mlist=self)
